<template>
  <div>
    <div class="project-container">
      <h1 class="project-name">{{ name() }}</h1>
      <p>Last modified on {{ lastActivity }}.</p>
      <button class="button" v-on:click="hidden ? $emit('hide') : $emit('unhide')" v-text="hidden ? 'Expand' : 'Collapse'"></button>
    </div>
    <div class="projects" v-show="!hidden">
      <div class="description-container">
        <h2>Description</h2>
        <p>{{ desc() }}</p>
      </div>
      <div class="lang-container">
        <h2>Languages used:</h2>
        <div class="list">
          <ul v-for="language in languages()" :key="language">
            <li>{{ language }}</li>
          </ul>
        </div>
      </div>
      <div class="resource-container">
        <h2>Resources used:</h2>
        <div class="list">
          <ul v-for="resource in resources()" :key="resource">
            <li>{{ resource }}</li>
          </ul>
        </div>
      </div>
      <div class="link-container">
        <h2>Links</h2>
        <div class="link-list">
          <a :href="repo()" target="_blank">Repository link</a>
          <a id="site-link" class="site-link" v-if="url() != 'N/A'" :href="url()" target="_blank">Link to Site</a>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "Project",
  props: {
    readme: String,
    hidden: Boolean,
    lastActivity: String
  },
  data() {
    return {
      // readme: [],
      // hidden: [],
      // project: []
    }
  },
  methods: {
    name: function () {
      if(typeof this.readme === 'string' && this.readme.indexOf("Build Status") !== -1) {
        return this.readme.substring(2, this.readme.search("Build Status") - 3);
      }
      return this.readme.substring(2, this.readme.search("##"));
    },
    repo: function () {
      return this.readme.substring(this.readme.search("Repository link") + "Repository.link".length, this.readme.search("## URL"));
    },
    url: function () {
      let url = this.readme.substring(this.readme.search("URL") + "URL".length, this.readme.search("## Description"))

      if(url.includes('N/A')) {
        return "N/A"
      }

      return url
    },
    desc: function () {
      let desc = this.readme.substring(this.readme.search("Description") + "Description".length, this.readme.search("## Languages"))
      desc = desc.replaceAll("</br>", "\n")

      return desc;
    },
    languages: function () {
      // The additional addition and subtraction is to remove new line characters
      return this.readme.substring(this.readme.search("Languages") + "Languages".length + 1,
          this.readme.search("## Resources Used") - 2).split("\\\n");
    },
    resources: function () {
      return this.readme.substring(this.readme.search("Resources Used") + "Resources Used".length + 1,
          this.readme.search("==================") - 2).split("\\\n");
    }
  }
}
</script>

<style scoped>

.project-container,
.description-container,
.lang-container,
.resource-container,
.link-container {
  background-color: #395f4d;
  padding: 10px 30px;
  border-radius: 25px;
  margin: 15px 0;
}

.description-container,
.lang-container,
.resource-container,
.link-container {
  background-color: #288263;
}

.description-container {
  white-space: pre-line;
}

.project-name {
  margin: 5px 0;
}

h1, h2 {
  font-family: "Roboto Condensed", "Arial", sans-serif;
}

h1, h2 {
  font-size: 45px;
  text-align: center;

  display: grid;
  width: 100%;
  align-items: center;
  grid-template-columns: minmax(20px, 1fr) auto minmax(20px, 1fr);
  grid-gap: 20px;
}

h1:before, h1:after, h2:before, h2:after {
  content: '';
  border-top: 2px solid green;
}

p, li, a {
  font-family: "Roboto Condensed", "Arial", sans-serif;
  font-size: 20px;
  line-height: 1.4;
}

a {
  display: block;

  color: turquoise;
  text-decoration: underline;
  font-size: 22px;
}

a:hover,
a:focus {
  text-decoration: none;
}

.site-link {
  width: 110px;
  margin-left: auto;
  margin-right: auto;
}

.project-container p {
  text-align: center;
}

.list {
  column-count: 3;
  -moz-column-fill: balance;
  column-fill: balance;
}

ul {
  margin: 0;
  display: block;
}

.link-list {
  display: grid;
  grid-template-columns: 200px auto;
  grid-template-rows: auto;
}


/* CSS */
.button {
  align-content: center;
  background-color: #2ea44f;
  border: 1px solid rgba(27, 31, 35, .15);
  border-radius: 6px;
  box-shadow: rgba(27, 31, 35, .1) 0 1px 0;
  box-sizing: border-box;
  color: #fff;
  cursor: pointer;
  display: inline-block;
  font-family: -apple-system, system-ui, "Segoe UI", Helvetica, Arial, sans-serif, "Apple Color Emoji", "Segoe UI Emoji";
  font-size: 14px;
  font-weight: 600;
  left: 49%;
  line-height: 20px;
  padding: 6px 16px;
  position: relative;
  text-align: center;
  text-decoration: none;
  user-select: none;
  -webkit-user-select: none;
  touch-action: manipulation;
  vertical-align: middle;
  white-space: nowrap;
}

.button:focus:not(:focus-visible):not(.focus-visible) {
  box-shadow: none;
  outline: none;
}

.button:hover {
  background-color: #2c974b;
}

.button:focus {
  box-shadow: rgba(46, 164, 79, .4) 0 0 0 3px;
  outline: none;
}

.button:disabled {
  background-color: #94d3a2;
  border-color: rgba(27, 31, 35, .1);
  color: rgba(255, 255, 255, .8);
  cursor: default;
}

.button:active {
  background-color: #298e46;
  box-shadow: rgba(20, 70, 32, .2) 0 1px 0 inset;
}

@media (max-width: 1260px) {
  .list {
    column-count: 2;
    -moz-column-fill: balance;
    column-fill: balance;
  }
}
</style>
